diff --git a/base/deploy/src/scriptlets/pkiparser.py b/base/deploy/src/scriptlets/pkiparser.py
index 0add192..5abfdc0 100644
--- a/base/deploy/src/scriptlets/pkiparser.py
+++ b/base/deploy/src/scriptlets/pkiparser.py
@@ -654,6 +909,78 @@ def compose_pki_master_dictionary():
         config.pki_master_dict['pki_subsystem_logs_link'] =\
             os.path.join(config.pki_master_dict['pki_subsystem_path'],
                          "logs")
+        # PKI Target (war file) name/value pairs
+        if config.pki_master_dict['pki_subsystem'] in\
+           config.PKI_TOMCAT_SUBSYSTEMS:
+            # Tomcat PKI subsystem war file base name/value pairs
+            config.pki_master_dict['pki_tomcat_webapps_subsystem_path'] =\
+                os.path.join(config.pki_master_dict['pki_tomcat_webapps_path'],
+                             config.pki_master_dict['pki_subsystem'].lower())
+            config.pki_master_dict\
+            ['pki_tomcat_webapps_subsystem_webinf_classes_path'] =\
+                os.path.join(
+                    config.pki_master_dict['pki_tomcat_webapps_subsystem_path'],
+                    "WEB-INF",
+                    "classes")
+            config.pki_master_dict\
+            ['pki_tomcat_webapps_subsystem_webinf_lib_path'] =\
+                os.path.join(
+                    config.pki_master_dict['pki_tomcat_webapps_subsystem_path'],
+                    "WEB-INF",
+                    "lib")
+            # Tomcat PKI subsystem war file convenience symbolic links
+            if config.pki_master_dict['pki_subsystem'] == "CA":
+                config.pki_master_dict['pki_ca_jar'] =\
+                    os.path.join(config.PKI_DEPLOYMENT_PKI_JAR_SOURCE_ROOT,
+                                 "pki-ca.jar")
+                # config.pki_master_dict['pki_ca_jar_link'] =\
+                #     os.path.join(
+                #         config.pki_master_dict\
+                #         ['pki_tomcat_webapps_subsystem_webinf_lib_path'],
+                #         "pki-ca.jar")
+                config.pki_master_dict['pki_ca_jar_link'] =\
+                    os.path.join(
+                        config.pki_master_dict['pki_tomcat_common_lib_path'],
+                        "pki-ca.jar")
+            elif config.pki_master_dict['pki_subsystem'] == "KRA":
+                config.pki_master_dict['pki_kra_jar'] =\
+                    os.path.join(config.PKI_DEPLOYMENT_PKI_JAR_SOURCE_ROOT,
+                                 "pki-kra.jar")
+                # config.pki_master_dict['pki_kra_jar_link'] =\
+                #     os.path.join(
+                #         config.pki_master_dict\
+                #         ['pki_tomcat_webapps_subsystem_webinf_lib_path'],
+                #         "pki-kra.jar")
+                config.pki_master_dict['pki_kra_jar_link'] =\
+                    os.path.join(
+                        config.pki_master_dict['pki_tomcat_common_lib_path'],
+                        "pki-kra.jar")
+            elif config.pki_master_dict['pki_subsystem'] == "OCSP":
+                config.pki_master_dict['pki_ocsp_jar'] =\
+                    os.path.join(config.PKI_DEPLOYMENT_PKI_JAR_SOURCE_ROOT,
+                                 "pki-ocsp.jar")
+                # config.pki_master_dict['pki_ocsp_jar_link'] =\
+                #     os.path.join(
+                #         config.pki_master_dict\
+                #         ['pki_tomcat_webapps_subsystem_webinf_lib_path'],
+                #         "pki-ocsp.jar")
+                config.pki_master_dict['pki_ocsp_jar_link'] =\
+                    os.path.join(
+                        config.pki_master_dict['pki_tomcat_common_lib_path'],
+                        "pki-ocsp.jar")
+            elif config.pki_master_dict['pki_subsystem'] == "TKS":
+                config.pki_master_dict['pki_tks_jar'] =\
+                    os.path.join(config.PKI_DEPLOYMENT_PKI_JAR_SOURCE_ROOT,
+                                 "pki-tks.jar")
+                # config.pki_master_dict['pki_tks_jar_link'] =\
+                #     os.path.join(
+                #         config.pki_master_dict\
+                #         ['pki_tomcat_webapps_subsystem_webinf_lib_path'],
+                #         "pki-tks.jar")
+                config.pki_master_dict['pki_tks_jar_link'] =\
+                    os.path.join(
+                        config.pki_master_dict['pki_tomcat_common_lib_path'],
+                        "pki-tks.jar")
         # PKI Target (slot substitution) name/value pairs
         config.pki_master_dict['pki_target_cs_cfg'] =\
             os.path.join(
@@ -699,12 +1026,50 @@ def compose_pki_master_dictionary():
                     config.pki_master_dict['pki_tomcat_webapps_subsystem_path'],
                     "WEB-INF",
                     "web.xml")
+            config.pki_master_dict['pki_target_subsystem_web_xml_orig'] =\
+                os.path.join(
+                    config.pki_master_dict['pki_tomcat_webapps_subsystem_path'],
+                    "WEB-INF",
+                    "web.xml.orig")
             # subystem-specific slot substitution name/value pairs
             if config.pki_master_dict['pki_subsystem'] == "CA":
+                config.pki_master_dict['pki_target_flatfile_txt'] =\
+                    os.path.join(config.pki_master_dict\
+                                 ['pki_subsystem_configuration_path'],
+                                 "flatfile.txt")
                 config.pki_master_dict['pki_target_proxy_conf'] =\
                     os.path.join(config.pki_master_dict\
                                  ['pki_subsystem_configuration_path'],
                                  "proxy.conf")
+                config.pki_master_dict['pki_target_registry_cfg'] =\
+                    os.path.join(config.pki_master_dict\
+                                 ['pki_subsystem_configuration_path'],
+                                 "registry.cfg")
+                # '*.profile'
+                config.pki_master_dict['pki_target_admincert_profile'] =\
+                    os.path.join(config.pki_master_dict\
+                                 ['pki_subsystem_configuration_path'],
+                                 "adminCert.profile")
+                config.pki_master_dict['pki_target_caauditsigningcert_profile']\
+                    = os.path.join(config.pki_master_dict\
+                                   ['pki_subsystem_configuration_path'],
+                                   "caAuditSigningCert.profile")
+                config.pki_master_dict['pki_target_cacert_profile'] =\
+                    os.path.join(config.pki_master_dict\
+                                 ['pki_subsystem_configuration_path'],
+                                 "caCert.profile")
+                config.pki_master_dict['pki_target_caocspcert_profile'] =\
+                    os.path.join(config.pki_master_dict\
+                                 ['pki_subsystem_configuration_path'],
+                                 "caOCSPCert.profile")
+                config.pki_master_dict['pki_target_servercert_profile'] =\
+                    os.path.join(config.pki_master_dict\
+                                 ['pki_subsystem_configuration_path'],
+                                 "serverCert.profile")
+                config.pki_master_dict['pki_target_subsystemcert_profile'] =\
+                    os.path.join(config.pki_master_dict\
+                                 ['pki_subsystem_configuration_path'],
+                                 "subsystemCert.profile")
                 # in-place slot substitution name/value pairs
                 config.pki_master_dict['pki_target_profileselect_template'] =\
                     os.path.join(
@@ -713,6 +1078,24 @@ def compose_pki_master_dictionary():
                         "ee",
                         config.pki_master_dict['pki_subsystem'].lower(),
                         "ProfileSelect.template")
+            elif config.pki_master_dict['pki_subsystem'] == "KRA":
+                # '*.profile'
+                config.pki_master_dict['pki_target_servercert_profile'] =\
+                    os.path.join(config.pki_master_dict\
+                                 ['pki_subsystem_configuration_path'],
+                                 "serverCert.profile")
+                config.pki_master_dict['pki_target_storagecert_profile'] =\
+                    os.path.join(config.pki_master_dict\
+                                 ['pki_subsystem_configuration_path'],
+                                 "storageCert.profile")
+                config.pki_master_dict['pki_target_subsystemcert_profile'] =\
+                    os.path.join(config.pki_master_dict\
+                                 ['pki_subsystem_configuration_path'],
+                                 "subsystemCert.profile")
+                config.pki_master_dict['pki_target_transportcert_profile'] =\
+                    os.path.join(config.pki_master_dict\
+                                 ['pki_subsystem_configuration_path'],
+                                 "transportCert.profile")
         # Slot assignment name/value pairs
         #     NOTE:  Master key == Slots key; Master value ==> Slots value
         config.pki_master_dict['PKI_INSTANCE_ID_SLOT'] =\
@@ -830,6 +1213,8 @@ def compose_pki_master_dictionary():
                              "tomcat")
             config.pki_master_dict['PKI_PROXY_SECURE_PORT_SLOT'] =\
                 config.pki_master_dict['pki_proxy_https_port']
+            config.pki_master_dict['PKI_TMPDIR_SLOT'] =\
+                config.pki_master_dict['pki_tomcat_tmpdir_path']
             config.pki_master_dict['PKI_PROXY_UNSECURE_PORT_SLOT'] =\
                 config.pki_master_dict['pki_proxy_http_port']
             config.pki_master_dict['PKI_RANDOM_NUMBER_SLOT'] =\
@@ -846,6 +1231,8 @@ def compose_pki_master_dictionary():
                 config.pki_master_dict['pki_security_manager']
             config.pki_master_dict['PKI_SERVER_XML_CONF_SLOT'] =\
                 config.pki_master_dict['pki_target_server_xml']
+            config.pki_master_dict['PKI_SUBSYSTEM_DIR_SLOT'] =\
+                config.pki_master_dict['pki_subsystem'].lower() + "/"
             config.pki_master_dict['PKI_SUBSYSTEM_TYPE_SLOT'] =\
                 config.pki_master_dict['pki_subsystem'].lower()
             config.pki_master_dict['PKI_SYSTEMD_SERVICENAME_SLOT'] =\
@@ -924,6 +1311,10 @@ def compose_pki_master_dictionary():
                 "+TLS_DHE_RSA_WITH_AES_128_CBC_SHA," +\
                 "+TLS_DHE_RSA_WITH_AES_256_CBC_SHA"
         # Shared Apache/Tomcat NSS security database name/value pairs
+        config.pki_master_dict['pki_shared_pfile'] =\
+            os.path.join(
+                config.pki_master_dict['pki_instance_configuration_path'],
+                "pfile")
         config.pki_master_dict['pki_shared_password_conf'] =\
             os.path.join(
                 config.pki_master_dict['pki_instance_configuration_path'],
@@ -941,13 +1332,13 @@ def compose_pki_master_dictionary():
         config.pki_master_dict['pki_self_signed_nickname'] =\
             "Server-Cert cert-" + config.pki_master_dict['pki_instance_id']
         config.pki_master_dict['pki_self_signed_subject'] =\
-            "CN=" + config.pki_master_dict['pki_hostname'] + "," +\
-            "O=" + config.pki_master_dict['pki_certificate_timestamp']
+            "cn=" + config.pki_master_dict['pki_hostname'] + "," +\
+            "o=" + config.pki_master_dict['pki_certificate_timestamp']
         config.pki_master_dict['pki_self_signed_serial_number'] = 0
         config.pki_master_dict['pki_self_signed_validity_period'] = 12
         config.pki_master_dict['pki_self_signed_issuer_name'] =\
-            "CN=" + config.pki_master_dict['pki_hostname'] + "," +\
-            "O=" + config.pki_master_dict['pki_certificate_timestamp']
+            "cn=" + config.pki_master_dict['pki_hostname'] + "," +\
+            "o=" + config.pki_master_dict['pki_certificate_timestamp']
         config.pki_master_dict['pki_self_signed_trustargs'] = "CTu,CTu,CTu"
         config.pki_master_dict['pki_self_signed_noise_file'] =\
             os.path.join(
